var FireDownloadOverlay = {
  init : function fd_init(e) {
    window.addEventListener("unload", FireDownloadOverlay.cleanup, false);
  
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", FireDownloadOverlay.popupShowing, false);
  },
  
  cleanup : function fd_cleanup(e) {
    window.removeEventListener("unload", FireDownloadOverlay.cleanup, false);
    window.removeEventListener("load", FireDownloadOverlay.init, false);
    document.getElementById("contentAreaContextMenu").removeEventListener("popupshowing", FireDownloadOverlay.popupShowing, false);
  },
  
  popupShowing : function fd_popupShowing(e) {
    var anchor = document.popupNode;
    while (anchor && !(anchor instanceof HTMLAnchorElement)) {
      anchor = anchor.parentNode;
    }

    document.getElementById("firedownload-savelink").hidden = (anchor == null);
  },

  saveLink : function fd_saveLink()
  {
    var anchor = document.popupNode;
    while (anchor && !(anchor instanceof HTMLAnchorElement)) {
      anchor = anchor.parentNode;
    }

    if (!anchor)
      return;

    var fireDownload = Cc["@mozilla.org/firedownload;1"].createInstance(Ci.nsIFireDownload);
    fireDownload.startDownload(anchor.href, "");
  }
};

window.addEventListener("load", FireDownloadOverlay.init, false);
